<?php

include("recaptcha.php");

$domain = $_SERVER["SERVER_NAME"];
$fullName = htmlspecialchars($_POST["fullName"]);
$emailAddress = htmlspecialchars($_POST["emailAddress"]);
$phoneNumber = htmlspecialchars($_POST["phoneNumber"]);
$subject = htmlspecialchars($_POST["subject"]);
$message = htmlspecialchars($_POST["message"]);
$form = htmlspecialchars($_POST["form"]);

$firstTitle = "New contact email";

if(!empty($form)) {
    $page = $form;
} else {
    $page = "contact-us.html";
};

// RECEIVER
$receiver = "info@crowbarcode.com";
$adminContact = "admin@crowbarcode.com";

if($recaptchaEnabled) {

        // Validate reCAPTCHA box 
    if(isset($_POST['g-recaptcha-response']) && !empty($_POST['g-recaptcha-response'])){ 

        // Verify the reCAPTCHA response 
        $verifyResponse = file_get_contents('https://www.google.com/recaptcha/api/siteverify?secret='.$secretKey.'&response='.$_POST['g-recaptcha-response']); 
            
        // Decode json data 
        $responseData = json_decode($verifyResponse); 
            
        // If reCAPTCHA response is valid 
        if($responseData->success){ 
        
            sendForm(
                $page, 
                $fullName, 
                $emailAddress, 
                $phoneNumber, 
                $subject, 
                $message, 
                $receiver,
                $adminContact,
                $siteKey, 
                $secretKey
            );
        
        } else { 
        
            header(
                "Location: ../$page?flag=danger&message=Falha na verificação do reCAPTCHA, tente novamente"
            );
        
        } 
        } else { 
        
            header(
                "Location: ../$page?flag=danger&message=Você precisa passar na verificação do reCAPTCHA para enviar o formulário. Tente novamente!"
            );
        
    };

} else {

    sendForm(
        $page, 
        $fullName, 
        $emailAddress, 
        $phoneNumber, 
        $subject, 
        $message, 
        $receiver, 
        $adminContact, 
        $siteKey, 
        $secretKey
    );

};

function sendForm(
    $page, 
    $fullName, 
    $emailAddress, 
    $phoneNumber,
    $subject, 
    $message, 
    $receiver, 
    $adminContact, 
    $siteKey, 
    $secretKey
) {

    if (
        !empty($fullName) &&
        !empty($emailAddress) &&
        !empty($subject) &&
        !empty($message)
    ) {
        if (filter_var($emailAddress, FILTER_VALIDATE_EMAIL)) {
    
            $subject_title =
                "=?UTF-8?B?" .
                base64_encode("$subject - $fullName <$emailAddress>") .
                "?=";
            $body = "
            A new message sent from the Inexus template form

            The subject of the message is: $subject

            Message details are below:

            Full Name: $fullName
            Email Address: $emailAddress
            Phone Number: $phoneNumber

            Message: $message
            ";
            $sender = "From: $emailAddress";
            if (mail($receiver, $subject_title, $body, $sender)) {
                header(
                    "Location: ../$page?flag=success&message=Your message has been sent successfully. Soon we will contact you."
                );
            } else {
                header("Status: 301 Moved Permanently", false, 301);
                header(
                    "Location: ../$page?flag=danger&message=The server is not properly configured to send messages. Please contact the administrator $adminContact"
                );
            }
        } else {
            header(
                "Location: ../$page?flag=danger&message=An error occurred while trying to send the message. Try later!"
            );
        }
    } else {
        header(
            "Location: ../$page?flag=danger&message=Some required fields were not filled out"
        );
    }

};

?>